/// Joystick.h
///
/// (c) 2001-2006 by Bastian Spiegel <bs@tkscript.de>
///     - Distributed under terms of the Lesser GNU General Public License (LGPL).
///       See COPYING and <http://www.gnu.org/licenses/licenses.html#LGPL> for further information.
///
///
#ifndef __TKSDL_JOYSTICK_H__
#define __TKSDL_JOYSTICK_H__

YG("hal1");


YC class _Joystick : public YAC_Object {
private:
	void         *sdl_joystick;
	YAC_String    name;

public:
//#define SDL_HAT_CENTERED  YCI 0x0
//#define SDL_HAT_UP        YCI 0x1
//#define SDL_HAT_RIGHT     YCI 0x2
//#define SDL_HAT_DOWN      YCI 0x4
//#define SDL_HAT_LEFT      YCI 0x8
//#define SDL_HAT_RIGHTUP   YCI 0x3
//#define SDL_HAT_RIGHTDOWN YCI 0x6
//#define SDL_HAT_LEFTUP    YCI 0x9
//#define SDL_HAT_LEFTDOWN  YCI 0xc


public:
	_Joystick(void);
	~_Joystick();

	YAC(_Joystick);

	void open(sS32);
	void close(void);

	void YAC_CALL yacOperator(sSI, YAC_Object*, YAC_Value *);

	// ------------ exported methods ------------
	YM sSI  _getAxis        (sSI);
	YM sSI  _getBall        (sSI, YAC_Object *_ivector);
	YM sSI  _getButton      (sSI);
	YM sSI  _getHat         (sSI);
	YM sSI  _getIndex       (void);
	YM sSI  _getNumAxes     (void);
	YM sSI  _getNumBalls    (void);
	YM sSI  _getNumButtons  (void);
	YM sSI  _getNumHats     (void);
	YM void _getName        (YAC_Value *_r);
};



#endif
