/// Key.h
///
/// (c) 2001-2006 by Bastian Spiegel <bs@tkscript.de>
///     - Distributed under terms of the Lesser GNU General Public License (LGPL).
///       See COPYING and <http://www.gnu.org/licenses/licenses.html#LGPL> for further information.
///
///
#ifndef __TKSDL_KEY_H__
#define __TKSDL_KEY_H__

YG("hal1");


#define VKEY_PRESSED 0x40000000


YC class _Key : public YAC_Object {
public:

#define VKEY_BACKSPACE  YCI 8 
#define VKEY_TAB        YCI 9
#define VKEY_CLEAR      YCI 12
#define VKEY_RETURN     YCI 13
#define VKEY_PAUSE      YCI 19
#define VKEY_ESCAPE     YCI 27
#define VKEY_SPACE      YCI 32
#define VKEY_EXCLAIM    YCI 33
#define VKEY_QUOTEDBL   YCI 34
#define VKEY_HASH       YCI 35
#define VKEY_DOLLAR     YCI 36
#define VKEY_AMPERSAND  YCI 38
#define VKEY_QUOTE      YCI 39
#define VKEY_LEFTPAREN  YCI 40
#define VKEY_RIGHTPAREN YCI 41
#define VKEY_ASTERISK   YCI 42
#define VKEY_PLUS       YCI 43
#define VKEY_COMMA      YCI 44
#define VKEY_MINUS      YCI 45
#define VKEY_PERIOD     YCI 46
#define VKEY_SLASH      YCI 47
#define VKEY_0          YCI 48
#define VKEY_1          YCI 49
#define VKEY_2          YCI 50
#define VKEY_3          YCI 51
#define VKEY_4          YCI 52
#define VKEY_5          YCI 53
#define VKEY_6          YCI 54
#define VKEY_7          YCI 55
#define VKEY_8          YCI 56
#define VKEY_9          YCI 57
#define VKEY_COLON      YCI 58
#define VKEY_SEMICOLON  YCI 59
#define VKEY_LESS       YCI 60
#define VKEY_EQUALS     YCI 61
#define VKEY_GREATER    YCI 62
#define VKEY_QUESTION   YCI 63
#define VKEY_AT         YCI 64
#define VKEY_LEFTBRACKET YCI 91
#define VKEY_BACKSLASH  YCI 92
#define VKEY_RIGHTBRACKET YCI 93
#define VKEY_CARET        YCI 94
#define VKEY_UNDERSCORE   YCI 95
#define VKEY_BACKQUOTE    YCI 96
#define VKEY_DELETE       YCI 127
	/* Numeric keypad */
#define VKEY_KP0          YCI 256
#define VKEY_KP1          YCI 257
#define VKEY_KP2          YCI 258
#define VKEY_KP3          YCI 259
#define VKEY_KP4          YCI 260
#define VKEY_KP5          YCI 261
#define VKEY_KP6          YCI 262
#define VKEY_KP7          YCI 263
#define VKEY_KP8          YCI 264
#define VKEY_KP9          YCI 265
#define VKEY_KP_PERIOD    YCI 266
#define VKEY_KP_DIVIDE    YCI 267
#define VKEY_KP_MULTIPLY  YCI 268
#define VKEY_KP_MINUS     YCI 269
#define VKEY_KP_PLUS      YCI 270
#define VKEY_KP_ENTER     YCI 271
#define VKEY_KP_EQUALS    YCI 272
	/* Arrows + Home/End pad */
#define VKEY_UP           YCI 273
#define VKEY_DOWN         YCI 274
#define VKEY_RIGHT        YCI 275
#define VKEY_LEFT         YCI 276
#define VKEY_INSERT       YCI 277
#define VKEY_HOME         YCI 278
#define VKEY_END          YCI 279
#define VKEY_PAGEUP       YCI 280
#define VKEY_PAGEDOWN     YCI 281
	/* Function keys */
#define VKEY_F1           YCI 282
#define VKEY_F2           YCI 283
#define VKEY_F3           YCI 284
#define VKEY_F4           YCI 285
#define VKEY_F5           YCI 286
#define VKEY_F6           YCI 287
#define VKEY_F7           YCI 288
#define VKEY_F8           YCI 289
#define VKEY_F9           YCI 290
#define VKEY_F10          YCI 291
#define VKEY_F11          YCI 292
#define VKEY_F12          YCI 293
#define VKEY_F13          YCI 294
#define VKEY_F14          YCI 295
#define VKEY_F15          YCI 296
	/* Key state modifier keys */
#define VKEY_NUMLOCK      YCI 300
#define VKEY_CAPSLOCK     YCI 301
#define VKEY_SCROLLOCK    YCI 302
#define VKEY_RSHIFT       YCI 303
#define VKEY_LSHIFT       YCI 304
#define VKEY_RCTRL        YCI 305
#define VKEY_LCTRL        YCI 306
#define VKEY_RALT         YCI 307
#define VKEY_LALT         YCI 308
#define VKEY_RMETA        YCI 309
#define VKEY_LMETA        YCI 310
#define VKEY_LSUPER       YCI 311		/* Left "Windows" key */
#define VKEY_RSUPER       YCI 312		/* Right "Windows" key */
#define VKEY_MODE         YCI 313		/* "Alt Gr" key */
#define VKEY_COMPOSE      YCI 314   	/* Multi-key compose key */
	/* Miscellaneous function keys */
#define VKEY_HELP         YCI 315
#define VKEY_PRINT        YCI 316
#define VKEY_SYSREQ       YCI 317
#define VKEY_BREAK        YCI 318
#define VKEY_MENU         YCI 319
#define VKEY_POWER        YCI 320  	/* Power Macintosh power key */
#define VKEY_EURO         YCI 321	/* Some european keyboards */
/* virtual digital joystick key-events */
#define VKEY_MOUSEBUTTON0 YCI 65537
#define VKEY_MOUSEBUTTON1 YCI 65538 /* right  */
#define VKEY_MOUSEBUTTON2 YCI 65539 /* middle */
#define VKEY_MOUSEBUTTON3 YCI 65540 /* wheel up */
#define VKEY_MOUSEBUTTON4 YCI 65541 /* wheel down */
#define VKEY_JOY0AXIS0NEG YCI 65542 /* left */
#define VKEY_JOY0AXIS0POS YCI 65543 /* right */
#define VKEY_JOY0AXIS1NEG YCI 65544 /* up*/
#define VKEY_JOY0AXIS1POS YCI 65545 /* down */
#define VKEY_JOY0BUTTON0  YCI 65546
#define VKEY_JOY0BUTTON1  YCI 65547
#define VKEY_JOY0BUTTON2  YCI 65548
#define VKEY_JOY0BUTTON3  YCI 65549
#define VKEY_JOY0BUTTON4  YCI 65550
#define VKEY_JOY0BUTTON5  YCI 65551
#define VKEY_JOY0BUTTON6  YCI 65552
#define VKEY_JOY0BUTTON7  YCI 65553
#define VKEY_JOY0BUTTON8  YCI 65554
#define VKEY_JOY1AXIS0NEG YCI 65555
#define VKEY_JOY1AXIS0POS YCI 65556
#define VKEY_JOY1AXIS1NEG YCI 65557
#define VKEY_JOY1AXIS1POS YCI 65558
#define VKEY_JOY1BUTTON0  YCI 65559
#define VKEY_JOY1BUTTON1  YCI 65560
#define VKEY_JOY1BUTTON2  YCI 65561
#define VKEY_JOY1BUTTON3  YCI 65562
#define VKEY_JOY1BUTTON4  YCI 65563
#define VKEY_JOY1BUTTON5  YCI 65564
#define VKEY_JOY1BUTTON6  YCI 65565
#define VKEY_JOY1BUTTON7  YCI 65566
#define VKEY_JOY1BUTTON8  YCI 65567
#define VKEY_JOY2AXIS0NEG YCI 65568
#define VKEY_JOY2AXIS0POS YCI 65569
#define VKEY_JOY2AXIS1NEG YCI 65570
#define VKEY_JOY2AXIS1POS YCI 65571
#define VKEY_JOY2BUTTON0  YCI 65572
#define VKEY_JOY2BUTTON1  YCI 65573
#define VKEY_JOY2BUTTON2  YCI 65574
#define VKEY_JOY2BUTTON3  YCI 65575
#define VKEY_JOY2BUTTON4  YCI 65576
#define VKEY_JOY2BUTTON5  YCI 65577
#define VKEY_JOY2BUTTON6  YCI 65578
#define VKEY_JOY2BUTTON7  YCI 65579
#define VKEY_JOY2BUTTON8  YCI 65580
#define VKEY_JOY3AXIS0NEG YCI 65581
#define VKEY_JOY3AXIS0POS YCI 65582
#define VKEY_JOY3AXIS1NEG YCI 65583
#define VKEY_JOY3AXIS1POS YCI 65584
#define VKEY_JOY3BUTTON0  YCI 65585
#define VKEY_JOY3BUTTON1  YCI 65586
#define VKEY_JOY3BUTTON2  YCI 65587
#define VKEY_JOY3BUTTON3  YCI 65588
#define VKEY_JOY3BUTTON4  YCI 65589
#define VKEY_JOY3BUTTON5  YCI 65590
#define VKEY_JOY3BUTTON6  YCI 65591
#define VKEY_JOY3BUTTON7  YCI 65592
#define VKEY_JOY3BUTTON8  YCI 65593
//#define VKEY_PRESSED      YCI 0x40000000
/* additional modifiers */
#define VMOD_LSHIFT       YCI 1
#define VMOD_RSHIFT       YCI 2
#define VMOD_LCTRL        YCI 64
#define VMOD_RCTRL        YCI 128
#define VMOD_LALT         YCI 256
#define VMOD_RALT         YCI 512
#define VMOD_LMETA        YCI 1024
#define VMOD_RMETA        YCI 2048
#define VMOD_NUM          YCI 4096
#define VMOD_CAPS         YCI 8192
#define VMOD_MODE         YCI 16384
#define DCON              YCI 0
//#define STDOUT            YCI 1
//#define STDERR            YCI 2


public:
    sUI vkey;
    sUI vmod;
    sUI unicode;

public:
    _Key(void);
    _Key(sUI _vkey, sUI _vmod, sUI _unicode);
    ~_Key() { };

	YAC(_Key);

	const char *getCodeName(sUI _vkey);
	void appendModName(YAC_String *_s, sUI _vmod);
	sUI getCodeByName(YAC_String *);
	sUI getModByName(YAC_String *);
	void setModifiersByString(YAC_String *_s);
	
	void YAC_CALL yacSerialize(YAC_Object *, sUI);
	sUI  YAC_CALL yacDeserialize(YAC_Object *, sUI);
	
	void YAC_CALL yacOperator(sSI _cmd, YAC_Object *_o, YAC_Value *_r);
	
	 // ------------ exported methods ------------
	YM sUI _getCode      (void);
	YM sUI _getMod       (void);
	YM sUI _getPressed   (void);
	YM sUI _getReleased  (void);
	YM sUI _getAlpha     (void);
   YM sUI _getUnicode   (void);

	YM void _getCodeName (YAC_Value *_r);
	YM void _getModName  (YAC_Value *_r);
	YM void _getName     (YAC_Value *_r);
	YM void _getNameFor  (sUI _vkey, sUI _vmod, YAC_Value *_r);
	YM void _setCode     (sUI);
	YM void _setMod      (sUI);
	YM void _setPressed  (sUI);
	YM void _setReleased (sUI);
   YM void _setUnicode  (sSI);
	YM void _setAlpha    (sUI);
	YM void _setCodeName (YAC_String *_s);
	YM void _setModName  (YAC_String *_s);
	YM void _setName     (YAC_Object *_s);
   YM sSI  _modAlt      (void);
   YM sSI  _modShift    (void);
   YM sSI  _modCtrl     (void);
};


#endif
