/// Mutex.cpp
///
/// (c) 2002-2005 Bastian Spiegel <bs@tkscript.de> 
///     - Distributed under terms of the Lesser GNU General Public License (LGPL).
///       See COPYING and <http://www.gnu.org/licenses/licenses.html#LGPL> for further information.
///
///
/// changelog:
///      04Jul2002 <fli> file created
///      11Mar2005 source cleanup
///

#include "static_tksdl.h"

#include <stdio.h>
#include <stdlib.h>

#include <SDL/SDL.h>
#include <SDL/SDL_thread.h>

#include <yac.h>

#ifndef DX_STATIC_TKSDL
#include <tks-list.h>
#endif

#include <tks-opengl.h>
#include "Mutex.h"

extern YAC_Host *yac_host;


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~                                   ~
//~ Mutex                             ~
//~                                   ~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
_Mutex::_Mutex(void) {
  sdl_mutex=0;
}

_Mutex::~_Mutex() {
  _destroy();
}

void _Mutex::_create(void) {
  if(!sdl_mutex)
    sdl_mutex=::SDL_CreateMutex();
}

void _Mutex::_destroy(void) {
  if(sdl_mutex)
    {
      ::SDL_DestroyMutex(sdl_mutex);
      sdl_mutex=0;
    }
}

void _Mutex::_lock(void) {
  if(sdl_mutex)
    ::SDL_mutexP(sdl_mutex);
}

void _Mutex::_unlock(void) {
  if(sdl_mutex)
    ::SDL_mutexV(sdl_mutex);
}
