/// Thread.h
///
/// (c) 2002-2005 Bastian Spiegel <bs@tkscript.de>
///     - Distributed under terms of the Lesser GNU General Public License (LGPL).
///       See COPYING and <http://www.gnu.org/licenses/licenses.html#LGPL> for further information.
///
///
#ifndef __TKSDL_THREAD_H__
#define __TKSDL_THREAD_H__

YG("thread");

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~                                   ~
//~ Thread                            ~
//~                                   ~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
YC class _Thread : public YAC_Object {
public:
	SDL_Thread       *sdl_thread;
	void             *tks_entry_fun;
	YAC_Object       *user_data;
	SDL_mutex        *mtx_event_queue;
	SDL_mutex        *mtx_event_wait;
	StaticList::Node *action_queue;

public:
	_Thread(void);
	~_Thread();
	
	YAC(_Thread);

	YM sSI         _create            (YAC_Object *_funname);
	YM void        _kill              (void);
	YM sSI         _wait              (void);
	YM sSI         _getId             (void);
	YM void        _setUserdata       (YAC_Object*);
	YM YAC_Object *_getUserdata       (void);
	YM void        _event             (YAC_Object*);
	YM void        _getNextEvent      (YAC_Value *);
	YM void        _waitForNextEvent  (YAC_Value *);
	YM void        _cancelEvents      (void);
};


#endif

