/// SamplePlayer.h
///
/// (c) 2002-2006 by Bastian Spiegel <bs@tkscript.de>
///     - Distributed under terms of the Lesser GNU General Public License (LGPL).
///       See COPYING and <http://www.gnu.org/licenses/licenses.html#LGPL> for further information.
///
///

#ifndef __TKSDL_SAMPLEPLAYER_H__
#define __TKSDL_SAMPLEPLAYER_H__


YG("audio");

#define TKS_MAX_AUDIOVOICES 16


YC class _SamplePlayer : public YAC_Object {
public:
    sUI    polyphony; // max. # of voices
    sF32   volume;    // default channel volume
    sF32   pan;       // default channel panning
    sF32   finetune;  // default channel finetune

public:
    AudioSampleVoice voices[TKS_MAX_AUDIOVOICES];
    _AudioSample     *default_sample;


public:
    _SamplePlayer(void);
    ~_SamplePlayer();

	YAC(_SamplePlayer);

    void processSamples(sU32 _num, sF32 *_destbuf);

    void YAC_CALL yacOperator(sSI, YAC_Object*, YAC_Value *);

    YM void        _setPolyphony   (sSI);
    YM sSI         _getPolyphony   (void);
    YM void        _setVolume      (sF32);
    YM sF32        _getVolume      (void);
    YM void        _noteOn         (sSI _midinote, sF32 _volume);
    YM void        _noteOff        (sSI _note);
    YM YAC_Object *_getSample      (void);
    YM void        _setSample      (YAC_Object *_sample);
    YM void        _processSamples (YAC_Object *_fa);
    YM void        _setPan         (sF32 _v);
    YM sF32        _getPan         (void);
};

#endif
